﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CifraCesare
{
    public static class Cifrario
    {
        public const string Alfabeto = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

        public static string Sostituisci(string s, int chiave)
        {
            StringBuilder sb = new StringBuilder();

            foreach (char ch in s.ToUpper())
            {
                int i = Alfabeto.IndexOf(ch);         // Determina la posizione del carattere c all'interno dell'alfabeto
                if (i < 0)
                    throw new Exception(String.Format("Il carattere '{0}' non appartiene all'alfabeto", ch));

                int j = (i + chiave) % Alfabeto.Length; // Calcola la posizione del carattere cifrato
                if (j < 0)
                    j += Alfabeto.Length;

                sb.Append(Alfabeto[j]);
            }

            return sb.ToString();
        }

        public static string EstraiCaratteriAlfabeto(string s)
        {
            // Restituisce una stringa composta dai soli caratteri della 
            // stringa s (convertiti in maiuscolo) appartenenti all'alfabeto

            StringBuilder sb = new StringBuilder();

            foreach (char ch in s.ToUpper())

                if (Alfabeto.IndexOf(ch) >= 0)
                    sb.Append(ch);

            return sb.ToString();
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            string plainText, cipherText;

            Console.Write("Stringa da cifrare: ");
            plainText = Console.ReadLine();

            plainText = Cifrario.EstraiCaratteriAlfabeto(plainText);

            try
            {
                cipherText = Cifrario.Sostituisci(plainText, 3);
                Console.WriteLine(String.Format("Testo cifrato: {0}", cipherText));
            }
            catch (Exception e)
            {
                Console.Error.WriteLine(e.Message);
            }
        }
    }
}
