﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CifraPizzini
{
    public static class Pizzino
    {
        public const string Alfabeto = "ABCDEFGHILMNOPQRSTUVZ";

        public static int[] Trasforma(string s)
        {
            List<int> lista = new List<int>();

            foreach(Char ch in s.ToUpper()) {
                int idx = Alfabeto.IndexOf(ch);
                if (idx < 0)
                    throw new Exception(String.Format("Il carattere {0} non è valido.", ch));

                idx += (1 + 3);     // +1 per collocare l'indice all'interno dell'intervallo 1..21, +3 per applicare l'algoritmo
                lista.Add(idx);
            }
            
            return lista.ToArray();
        }

    }
    class Program
    {
        static void Main(string[] args)
        {
            string messaggio;

            Console.Write("Messaggio da cifrare: ");
            messaggio = Console.ReadLine();

            try
            {
                int[] numeri;
                numeri = Pizzino.Trasforma(messaggio);
                
                Console.WriteLine("Messaggio cifrato: ");

                foreach (int i in numeri)
                    Console.Write("{0}", i);

                Console.WriteLine("");
            }
            catch (Exception e)
            {
                Console.Error.WriteLine(e.Message);
            }
        }
    }
}
