﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DecifraCesare
{
    public static class Cifrario
    {
        public const string Alfabeto = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

        public static string Sostituisci(string s, int chiave)
        {
            StringBuilder sb = new StringBuilder();

            foreach (char ch in s.ToUpper())
            {
                int i = Alfabeto.IndexOf(ch);         // Determina la posizione del carattere c all'interno dell'alfabeto
                if (i < 0)
                    throw new Exception(String.Format("Il carattere '{0}' non appartiene all'alfabeto", ch));

                int j = (i + chiave) % Alfabeto.Length; // Calcola la posizione del carattere cifrato
                if (j < 0) 
                    j += Alfabeto.Length;

                sb.Append(Alfabeto[j]);
            }

            return sb.ToString();
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            string plainText, cipherText;

            Console.Write("Stringa da decifrare: ");
            cipherText = Console.ReadLine();

            try
            {
                plainText = Cifrario.Sostituisci(cipherText, -3);
                Console.WriteLine("Testo decifrato: {0}", plainText);
            }
            catch (Exception e)
            {
                Console.Error.WriteLine(e.Message);
            }
            
        }
    }
}
