﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DecifraChiave
{
    public static class Cifrario
    {
        public const string Alfabeto = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";

        public static string Sostituisci(string s, int chiave)
        {
            StringBuilder sb = new StringBuilder();

            foreach (char ch in s.ToUpper())
            {
                int i = Alfabeto.IndexOf(ch);         // Determina la posizione del carattere c all'interno dell'alfabeto
                if (i < 0)
                    throw new Exception(String.Format("Il carattere '{0}' non appartiene all'alfabeto", ch));

                int j = (i + chiave) % Alfabeto.Length; // Calcola la posizione del carattere cifrato
                if (j < 0)
                    j += Alfabeto.Length;

                sb.Append(Alfabeto[j]);
            }

            return sb.ToString();
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            string plainText, cipherText;
            int k;

            Console.Write("Stringa da decifrare: ");
            cipherText = Console.ReadLine();
            
            while (true)
            {
                try
                {
                    Console.Write("Chiave numerica: ");
                    string buffer = Console.ReadLine();

                    k = Convert.ToInt32(buffer);
                    break;
                }
                catch (Exception e) { 
                    Console.Error.WriteLine(e.Message); 
                }
            }
            
            try
            {
                plainText = Cifrario.Sostituisci(cipherText, -k);
                Console.WriteLine("Testo decifrato: {0}", plainText);
            }
            catch (Exception e)
            {
                Console.Error.WriteLine(e.Message);
            }

        }
    }
}
